#ifndef	_PATCH_H_
#define	_PATCH_H_

struct PatchRec
{
  int O;
  int A;
  int B;
};

BOOL PatchFile(char *FileName,PatchRec *APatch,int ASize,BOOL type)
{
  HANDLE F=CreateFile(FileName,GENERIC_READ|GENERIC_WRITE,0,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL);
  if(F==INVALID_HANDLE_VALUE) return FALSE;
  BYTE PS, PS2; DWORD Returned;
  for(int i=0;i<ASize;i++)
  {
    SetFilePointer(F,APatch[i].O,NULL,FILE_BEGIN);
    if(type)
      PS2=APatch[i].A;
    else
      PS2=APatch[i].B;
    if ((!ReadFile(F,&PS,sizeof(PS),&Returned,NULL)) || (Returned!=sizeof(PS)) || (PS!=PS2))
    {
      CloseHandle(F);
      return FALSE;
    }
    SetFilePointer(F,APatch[i].O,NULL,FILE_BEGIN);
    if(type)
      PS=APatch[i].B;
    else
      PS=APatch[i].A;
    if ((!WriteFile(F,&PS,sizeof(PS),&Returned,NULL)) || (Returned!=sizeof(PS)))
    {
      CloseHandle(F);
      return FALSE;
    }
  }
  CloseHandle(F);
  return TRUE;
}

BOOL FileExists(char *FileName)
{
  WIN32_FIND_DATA find; HANDLE hFind;
  hFind=FindFirstFile(FileName,&find);
  if(hFind!=INVALID_HANDLE_VALUE)
  {
    FindClose(hFind);
    return TRUE;
  }
  return FALSE;
}

#endif	/* Not _PATCH_H_ */
