#include <windows.h>
#include <stdio.h>

struct TranslateRec
{
  DWORD Layout;
  DWORD CP;
  DWORD Mask;
};

TranslateRec Table[]=
{
  {0x0401, 0x04E8, 0x007FF},
  {0x0405, 0x04E2, 0x007FF},
  {0x0413, 0x04E4, 0x007FF},
  {0x0409, 0x04E4, 0x007FF},
  {0x0408, 0x04E5, 0x007FF},
  {0x040D, 0x04E7, 0x007FF},
  {0x040E, 0x04E2, 0x007FF},
  {0x040F, 0x04E4, 0x007FF},
  {0x041D, 0x04E4, 0x007FF},
  {0x0414, 0x04E4, 0x007FF},
  {0x0415, 0x04E2, 0x007FF},
  {0x0419, 0x04E3, 0x007FF},
  {0x040A, 0x04E4, 0x007FF},
  {0x040B, 0x04E4, 0x007FF},
  {0x041F, 0x04E6, 0x007FF},
  {0x0411, 0x03A4, 0x007FF}, //Really not work
  {0x0804, 0x03A8, 0x007FF}, //I don't have
  {0x0404, 0x03B6, 0x007FF}, //chinize/japanize
  {0x0412, 0x03B5, 0x007FF}, //Windows
  {0x041E, 0x036A, 0x007FF}, //
  {0x0424, 0x04E2, 0x007FF},

  {0x0425, 0x04E9, 0x007FF}, //ESTONIAN
  {0x0426, 0x04E9, 0x007FF}, //LATVIAN
  {0x0427, 0x04E9, 0x007FF}, //LITHUANIAN

  {0x0C1A, 0x04E3, 0x00FFF}, //SERBIAN CYRILLIC
  {0x041A, 0x04E2, 0x00FFF}, //CROATIAN
  {0x081A, 0x04E2, 0x00FFF}, //SERBIAN LATIN: DON'T WORK IN MY NT40 SP6a
};

extern "C" {
  DWORD WINAPI _export GetKbd(void);
  int WINAPI dll_entry(int a,int b,int c);
};

DWORD WINAPI _export GetKbd(void)
{
  DWORD get_char;
  __asm__ volatile ("\n\
            movl      %%esi,%0\n\
            " : "=r" (get_char) /* allow use of reg eax, ebx, ecx, edx, esi, edi */
              :
            );
  DWORD layout=DWORD(GetKeyboardLayout(0));
  DWORD res=0;
  for(DWORD i=0;i<sizeof(Table)/sizeof(Table[0]);i++)
    if(Table[i].Layout==(layout&Table[i].Mask))
      res=Table[i].Layout+(1<<16)*Table[i].CP;
  if(!res)
    res=Table[3].Layout+(1<<16)*Table[3].CP;
  if(get_char)
  {
    char conv[1];
    wchar_t convW[1];
    conv[0]=get_char;
    if(MultiByteToWideChar(res>>16,0,conv,1,convW,1))
      res=convW[0];
    else
    {DWORD err=GetLastError(); FILE *log; log = fopen("c:\\bcopy.log", "at"); fprintf(log, "Err: %ld\n",err); fclose(log);}
  }
  return res;
}

int WINAPI dll_entry(int a,int b,int c)
{
  return 1;
}
